<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <!-- Nhúng các thư viện BS4 & jQuery, awesome font -->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <title>Address</title>
</head>
<body>
    <div class="container jumbotron">
        <h2 class="text-center mb-5">Địa chỉ người dùng</h2>
        <div class="row">
            <label for="province" class="col-sm-1">Tỉnh</label>
            <div class="col-sm-3">
                <select name="province" id="select-province" class="form-control">
                    <option value="none">Chọn tỉnh</option>
                </select>
            </div>

            <label for="district" class="col-sm-1">Huyện</label>
            <div class="col-sm-3">
                <select name="district" id="select-district" class="form-control" disabled>
                </select>
            </div>

            <label for="ward" class="col-sm-1">Xã</label>
            <div class="col-sm-3">
                <select name="ward" id="select-ward" class="form-control" disabled></select>
            </div>
        </div>
    </div>
</body>

<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */  
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();
    $("#select-province").on("change", function() {
        callApiToLoadSelectDistrictByProvinceId();
    });

    $("#select-district").on("change", function() {
        callApiToLoadSelectWardByDistrictId();
    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        callApiToLoadSelectProvince();
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    
    // Hàm gọi API để load dữ liệu toàn bộ các tỉnh vào thẻ select province
    function callApiToLoadSelectProvince() {
        $.ajax({
            type: "GET",
            url: "http://localhost:8080/provinces",
            success: function(paramRes) {
                console.log(paramRes);
                loadDataToSelectProvince(paramRes);
            },
            error: function(paramError) {
                console.log(paramError.status);
            }
        })
    }

    // Hàm load dữ liệu province trả về từ API vào thẻ select Province
    function loadDataToSelectProvince(paramDataProvince) {
        var vSelectProvince = $("#select-province");
        for(var i = 0; i < paramDataProvince.length; i++) {
            $("<option>", {
                text: paramDataProvince[i].name,
                value: paramDataProvince[i].id
            }).appendTo(vSelectProvince);
        }
    }


    // hàm gọi Api để load dữ liệu toàn bộ district thông qua id province
    function callApiToLoadSelectDistrictByProvinceId() {
        var vProvinceId = $("#select-province").val();
        if(vProvinceId != "none") {
            $.ajax({
                type: "GET",
                url: "http://localhost:8080/province/" + vProvinceId,
                success: function(paramRes) {
                    console.log(paramRes);
                    loadDataToSelectDistrict(paramRes);
                },
                error: function(paramError) {
                    console.log(paramError.status);
                }
            })
        }
        else {
            $("#select-district").prop("disabled", "disabled");
            $("#select-district").html("");

        }
    }

    // Hàm load dữ liệu district trả về sau khi call API
    function loadDataToSelectDistrict(paramDataDistrict) {
        var vSelectDistrict = $("#select-district");
        vSelectDistrict.prop("disabled", false);
        vSelectDistrict.html("");
        $("<option>", {
                value: "none",
                text: "Chọn quận, huyện"
            }).appendTo(vSelectDistrict);

        for(var i = 0; i < paramDataDistrict.length; i ++) {
            $("<option>", {
                value: paramDataDistrict[i].id,
                text: paramDataDistrict[i].prefix + " " + paramDataDistrict[i].name
            }).appendTo(vSelectDistrict);
        }
    }


    // Hàm gọi APi để load dữ liệu toàn bộ ward qua district Id
    function callApiToLoadSelectWardByDistrictId() {
        var vDistrictId = $("#select-district").val();
        if(vDistrictId != "none") {
            $.ajax({
                type: "GET",
                url: "http://localhost:8080/district?id=" + vDistrictId,
                success: function(paramRes) {
                    console.log(paramRes)
                    loadDataToSelectWard(paramRes);
                },
                error: function(paramError) {
                    console.log(paramError.status);
                }
            })
        }
        else {
            $("#select-ward").prop("disabled", "disabled");
            $("#select-ward").html("");

        }
    }

    // Hàm load dữ liệu ward trả về vào thẻ select ward
    function loadDataToSelectWard(paramDataWard) {
        var vSelectWard = $("#select-ward");
        vSelectWard.prop("disabled", false);
        vSelectWard.html("");
        $("<option>", {
                value: "none",
                text: "Chọn phường, xã"
            }).appendTo(vSelectWard);

        for(var i = 0; i < paramDataWard.length; i++) {
            $("<option>", {
                value: paramDataWard[i].id,
                text: paramDataWard[i].prefix + " " + paramDataWard[i].name
            }).appendTo(vSelectWard);
        }
    }
</script>
</html>